// =================================================================================
//	CircleObject.cp
// =================================================================================

#include "CircleObject.h"

#ifdef OOF_SmartHeap
	#include "smrtheap.hpp"
#endif


// ---------------------------------------------------------------------------------
//		 CircleObject
// ---------------------------------------------------------------------------------

CircleObject::CircleObject(int XIdeal, int YIdeal,
			int diameter, oofSeries* SeriesPtr, PositionState pos)
	: Geo(XIdeal,YIdeal, SeriesPtr, pos)
{
	mIdealDiameter = diameter;
}


// ---------------------------------------------------------------------------------
//		 drawSelf
// ---------------------------------------------------------------------------------

void
CircleObject::drawSelf(const oofDrawStyle* inStyle)
{
	inStyle->useStyleColors();
	#ifdef _Macintosh
	Rect	theRect;
	
	::SetRect(&theRect,mXDraw,mYDraw,
				mXDraw+mDrawDiameter,mYDraw+mDrawDiameter);
	::FrameOval(&theRect);
	#endif
}


// ---------------------------------------------------------------------------------
//		 Transform
// ---------------------------------------------------------------------------------

void
CircleObject::Transform( TransformationManager* inTransformationManagerPtr )
{
	int DrawRight,DrawBottom;
	inTransformationManagerPtr->TransformPoint
					(mXIdeal,mYIdeal,mXDraw,mYDraw);
	inTransformationManagerPtr->TransformPoint
					(mXIdeal+mIdealDiameter,mYIdeal+mIdealDiameter,
					DrawRight,DrawBottom);
	mDrawDiameter = DrawRight - mXDraw;
}