// Copyright 1994 A.D. Software. All Rights Reserved

// OOFTEST7

// this sample demonstrates searching and sorting by 
// different types of fields, and how to parameterize
// calls, passing in table and field references

// Simple stream I/O is used to interact with the user.
#include "oofile.hpp"


DECLARE_CLASS(dbPeople)
	dbChar		LastName, Othernames;
	dbLong		Salary, SalaryNoDup;
	dbShort		SalaryShort, SalaryShortNoDup;
	dbReal		SalaryReal, SalaryRealNoDup;
	dbDate		LastVisit, LastVisitNoDup;
	dbUshort	ShortUnsigned;
	dbUlong		LongUnsigned;

	dbPeople() :
				dbTable("People"),
				LastName(40, "Last Name", kIndexed),
				Othernames(80, "Other names", kIndexNoDups),
				Salary("Salary", kIndexed),
				SalaryNoDup("Salary NoDup", kIndexNoDups),
				SalaryShort("SalaryShort", kIndexed),
				SalaryShortNoDup("SalaryShortNoDup", kIndexNoDups),
				SalaryReal("SalaryReal", kIndexed),
				SalaryRealNoDup("SalaryRealNoDup", kIndexNoDups),
				LastVisit("LastVisit", kIndexed),
				LastVisitNoDup("LastVisitNoDup", kIndexNoDups),
				ShortUnsigned("ShortUnsigned", kIndexed),
				LongUnsigned("LongUnsigned", kIndexed)				
	{};
	
// my own data entry procedure
	void Add(const char *lname, const char *oname, const long salary, const char* visitDate);
};

	
#include "ooftst07.inc"

int main()
{
	cout << "OOFILE Validation Suite - Test 7\n"
		 << "Simple test to demonstrate comparative searches" << endl
		 << "using a database similar to ooftest2 but with lots of indexed fields" << endl;
	
	doTest07("ooftst07.db");
	return EXIT_SUCCESS;
}
