// COPYRIGHT 1994 A.D. Software, All rights reserved

// OOFILE database non-numeric fields

// inline definitions


// -------------------------------------------------------
//                   d b F i e l d
// -------------------------------------------------------
#if 0
inline dbField::operator dbField*() 
{ 
	return this; 
};
#endif

inline void 
dbField::operator=(const char* str)
{
	setString(str);  // this is a virtual call - a way to get a virtual operator= without the hassles of overriding
}


inline OOF_IndexOptions 
dbField::fieldIndexOptions() const
{
	return mIndexOptions;
}



inline bool 
dbField::fieldIndexAllowsDups() const
{
	return mIndexOptions!=kIndexNoDups;
} 


inline bool 
dbField::fieldIndexIsCompressLeading() const
{
	return mIndexOptions!=kIndexNoDups;
}


inline bool 
dbField::fieldIndexIsCompressPadding() const
{
	return mIndexOptions!=kIndexNoDups;
}


inline unsigned short 
dbField::fieldNumIndexes() const
{
	if (mIndexOptions==kNotIndexed)
		return 0;
	else
		return 1;  // NOT YET IMPLEMENTED - may later have multiple indexes/field
}


inline bool 
dbField::isStandalone() const
{
	return (mTable==0);
}


inline bool 
dbField::allowsDuplicates() const
{
	return !(mIndexOptions & kIndexNoDups);  
}


inline bool 
dbField::caseSensitive() const
{
	return (mIndexOptions & kIndexCaseSensitive);  
}


inline fieldNumT 
dbField::fieldNumber() const
{
	return mFieldNumber;  
}


inline unsigned long 
dbField::fieldDataLen() const
{
	assert(!isStandalone());
	return mBackend->fieldDataLen(this);  	
}


inline const OOF_String&
dbField::fieldName() const
{
	return mFieldName;  
}


inline const void* 
dbField::currentbinaryContents() const
{
	assert(!isStandalone());
	return mBackend->getFieldReadFrom(mFieldNumber);
}


inline ostream& 
operator<<(ostream& os, const dbField& fld)
{
	fld.extract(os);
	return os;
}


inline ostream& 
operator<<(ostream& os, const dbField* fld)
{
	fld->extract(os);
	return os;
}


// -------------------------------------------------------
//                      d b C h a r
// -------------------------------------------------------
// friend
inline ostream& 
operator<<(ostream& os, const dbChar& fld)
{
	fld.extract(os);
	return os;
}


inline void 
dbChar::setString(const char* str)
{
	dbChar::operator=(str);
}



// -------------------------------------------------------
//                  d b F i x e d B i n a r y
// -------------------------------------------------------
inline void 
dbFixedBinary::setString(const char* str)
{
	dbFixedBinary::operator=(str);
}


// -------------------------------------------------------
//                    d b B L O B 
// -------------------------------------------------------
inline bool 
dbBLOB::isDirty() const
{
	return mStorage->isDirty();
}


inline void 
dbBLOB::markDirty() const
{
	mStorage->markDirty();
}


inline bool 
dbBLOB::loaded() const
{
	return mStorage->mLoaded;
}


inline void* 
dbBLOB::bodyAddress() const
{
	return mStorage->bodyAddress();
}


inline void 
dbBLOB::reset() const
{
	mStorage->reset();
}


inline void* 
dbBLOB::allocRoomFor(unsigned long len) const
{
	return mStorage->allocRoomFor(len);
}


inline void* 
dbBLOB::orphanBody() const
{
	return mStorage->orphanBody();
}


inline void
dbBLOB::adoptBody(void* body, unsigned long bodyLen) const
{
	mStorage->adoptBody(body, bodyLen);
}


// -------------------------------------------------------
//                      d b T e x t
// -------------------------------------------------------
inline void 
dbText::setChars(const char* str , unsigned long charLen)
{
	mStorage->setChars(str, charLen);
}



inline ostream& 
operator<<(ostream& os, const dbText& fld)
{
	fld.extract(os);
	return os;
}



inline void 
dbText::setString(const char* str)
{
	dbText::operator=(str);
}


// -------------------------------------------------------
//               O O F _ S e g m e n t  
// -------------------------------------------------------

inline void 
OOF_Segment::setReverse()
{
	mReversed = true;
}


inline bool 
OOF_Segment::isReversed() const
{
	return mReversed;
}
 