#ifndef H_OOFMSG
#define H_OOFMSG
// COPYRIGHT 1996 A.D. Software, All rights reserved

// messaging layer of OOFILE database
typedef unsigned short OOFmsgT;
const OOFmsgT OOFmsg_ChangeSelection	= 1;
const OOFmsgT OOFmsg_ChangeContext	= OOFmsg_ChangeSelection + 1;
const OOFmsgT OOFmsg_UnloadRecord		= OOFmsg_ChangeContext + 1;
const OOFmsgT OOFmsg_NewRecord		= OOFmsg_UnloadRecord + 1;
const OOFmsgT OOFmsg_DeleteRecord		= OOFmsg_NewRecord + 1;
const OOFmsgT OOFmsg_SaveRecord		= OOFmsg_DeleteRecord + 1;
const OOFmsgT OOFmsg_BroadcasterClosing = OOFmsg_SaveRecord + 1;

const OOFmsgT OOFmsg_LastUsed = OOFmsg_BroadcasterClosing + 1;

	
class dbReceiver;
class OOF_ExpandableLongArray;

class dbBroadcaster  {
public:
	dbBroadcaster() :
		mReceivers(0)
	{};
	dbBroadcaster(const dbBroadcaster&) :
		mReceivers(0)
	{};
	~dbBroadcaster();
	
	void broadcast(OOFmsgT msg, unsigned long senderDefined=0);
	void addReceiver(dbReceiver*);
	void removeReceiver(const dbReceiver*);
	
protected:
// data storage
	OOF_ExpandableLongArray* mReceivers;
};


class dbReceiver  {
public:
	dbReceiver() {};
	// use default copy ctor
	virtual ~dbReceiver() {};
	virtual void subscribeTo(dbBroadcaster*);
	virtual void unsubscribe(dbBroadcaster*);
	virtual void receiveMsg(OOFmsgT msg, unsigned long senderDefined)=0;
};


class dbSingleListener : public dbReceiver {
public:
	dbSingleListener(dbBroadcaster* listensTo=0);
	dbSingleListener(const dbSingleListener&);
	virtual ~dbSingleListener();

	virtual void subscribeTo(dbBroadcaster*);
	virtual void unsubscribe(dbBroadcaster* from=0);
	
	void suspendListening();
	void resumeListening();
	
	virtual void receiveMsg(OOFmsgT msg, unsigned long senderDefined);
protected:
// data storage
	dbBroadcaster* mListensTo;
	dbBroadcaster* mSuspendedListensTo;
	unsigned short mSuspendCount;
};
#endif
