// Copyright 1994 A.D. Software. All Rights Reserved

// sample largish schema, showing generation of a test database with random data

// NOTE
// I ran with 15,000 records generated (30,000 total) in generateTestData
// taking roughly 17 minutes on a Q700 (25MHz '040).
//  container file size = 84.5Mb
//  total individual file sizes = 79.8Mb

#include "oofile.hpp"

// forward define classes used in relations
SET_TABLE(dbCategories)
REF_TABLE(dbEntries)

// define database classes

CLASS_TABLE(dbEntries)
// Locations dialog
	dbLong			   EntrySeq;
	dbChar				CompanyName,TradingName,Address,Phone1,Phone2,Fax;
	dbReal				GrossExportImport, AnnualTurnover;
	dbShort				NumEmployees, Type;
	dbText				theBlob;

	dbCategoriesSet			Categories;

	dbEntries():			dbTable("Entries"),
								EntrySeq("EntrySeq",kIndexed),
								CompanyName(80,"CompanyName",kIndexCompress),
								TradingName(80,"TradingName"),
								Address(80,"Address"),
								Phone1(17,"Phone1"),
								Phone2(17,"Phone2"),
								Fax(17,"Fax"),
								Type("Type"),
								GrossExportImport("GrossExportImport"),
								AnnualTurnover("AnnualTurnover"),
								NumEmployees("NumEmployees"),
								theBlob("blobbie")
	{};
};

CLASS_TABLE(dbCategories)
	dbLong			   EntrySeq;
	dbChar				Category;
	dbEntriesRef		Entry;

	dbCategories():	dbTable("dbCategories"),
							EntrySeq("EntrySeq",kIndexed),
							Category(80,"Category",kIndexCompress)
	{};

};

int main()
{
		dbConnect_ctree theDB;
		dbCategories 	categories;
		dbEntries 		entries;
		dbRelationship		entryCategories;

		entryCategories.lhs(entries.EntrySeq, entries.Categories);
		entryCategories.rhs(categories.EntrySeq, categories.Entry);


// *** CHANGE THE FOLLOWING #if 0  TO  #if 1
// *** TO TEST EITHER A FOLDER OF FILES, 
// *** OR A SINGLE DATABASE CONTAINER FILE
#if 1
		theDB.useSeparateFiles(); 
		if (dbConnect::fileExists("foodDB:Entries.dat"))
			theDB.openConnection("foodDB");
		else 
			theDB.newConnection("foodDB");
		
#else
		if (dbConnect::fileExists("foodDBcontainer"))
			theDB.openConnection("foodDBcontainer");
		else 
			theDB.newConnection("foodDBcontainer");
#endif	

	
		cout << "Generating test data" << endl << endl;

		theDB.generateTestData("testgen.in", 150);
		
		entries.selectAll();
		cout << "Num Entries: " << entries.count() << endl << endl;

		categories.selectAll();
		cout << "Num categories: " << categories.count() << endl << endl;

//   theDB.describe(cout);   // VERY BIG DUMP OF ALL DATA!!!!!

	exit(EXIT_SUCCESS);
	return EXIT_SUCCESS;
}
