//========================================================================================
//
//	File:				ContentView.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1996 by Bowers Development Corp., all rights reserved.
//
//========================================================================================

#ifndef CONTENTVIEW_H
#define CONTENTVIEW_H

// ----- Part Layer -----

#ifndef FWSVIEW_H
#include "FWSView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

//========================================================================================
// CContentView
//========================================================================================

class CContentView : public FW_CSuperView
{
public:
	FW_DECLARE_CLASS

public:		
	CContentView(Environment *ev, 
				FW_CSuperView* container, 
				const FW_CRect& bounds,
				const FW_CPoint& extent);
	virtual ~ CContentView();

private:
	CContentView(Environment *ev);

//----------------------------------------------------------------------------------------
// Inherited API
public:		
	virtual void		PostCreateViewFromStream(Environment *ev);

	// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment* ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment* ev, FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	New API
	virtual void		CalcExtent(Environment *ev);

//----------------------------------------------------------------------------------------
//	Private data
 private:
};

#endif
