//========================================================================================
//
//	File:				PictView.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1996 by Bowers Development Corp., all rights reserved.
//
//========================================================================================

#ifndef PICTVIEW_H
#define PICTVIEW_H

// ----- Part Layer -----

#ifndef FWVIEW_H
#include "FWView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class FW_CPictureShape;

//========================================================================================
// CPictView
//========================================================================================

class CPictView : public FW_CView
{
public:
	FW_DECLARE_CLASS

public:		
	CPictView(Environment *ev, 
				FW_CSuperView* container, 
				const FW_CRect& bounds,
				ODID viewId,
				FW_ResourceId resourceId);
	virtual ~ CPictView();

private:
	CPictView(Environment *ev);

//----------------------------------------------------------------------------------------
// Inherited API
public:		
	// ----- Drawing -----
	virtual void		Draw(Environment *ev, ODFacet* facet, ODShape* invalidShape);

	// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment* ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment* ev, FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	New API
protected: 
	void				InitPicture	(Environment*	ev,
									 FW_ResourceId	resourceId);

//----------------------------------------------------------------------------------------
//	Private data
private:
	FW_CPictureShape*	fPicture;
};

#endif
