//========================================================================================
//
//	File:				RadioGrp.h
//	Release Version:	$ ODF 1 $
//
//	Author:				Laurent Delamare, Spec Bowers
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef RADIOGRP_H
#define RADIOGRP_H

#ifndef FWSVIEW_H
#include "FWSView.h"
#endif

#ifndef FWCLUSTR_H
#include "FWClustr.h"
#endif

//========================================================================================
// CRadioGroup
//========================================================================================

class CRadioGroup : public FW_CSuperView
{
public:
	FW_DECLARE_CLASS

public:		
	CRadioGroup(Environment *ev, 
				FW_CSuperView* container, 
				const FW_CRect& bounds,
				ODID viewId,
				const FW_CPoint& extent);
	virtual ~ CRadioGroup();

private:
	CRadioGroup(Environment *ev);

//----------------------------------------------------------------------------------------
// Inherited API
public:		
	// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment* ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment* ev, FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	New API
public:		
	ODID				GetValue(Environment* ev) const;
	virtual void		SetValue(Environment* ev, ODID value);

//----------------------------------------------------------------------------------------
//	Private data
 private:
	FW_CRadioCluster*	fRadioCluster;
};

//----------------------------------------------------------------------------------------
// inlines
//----------------------------------------------------------------------------------------

inline ODID CRadioGroup::GetValue(Environment* ev) const
{
	return fRadioCluster->GetButtonIdOn(ev);
}

#endif
