//========================================================================================
//
//	File:				RectView.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1996 by Bowers Development Corp., all rights reserved.
//
//========================================================================================

#ifndef RECTVIEW_H
#define RECTVIEW_H

// ----- Part Layer -----

#ifndef FWSVIEW_H
#include "FWSView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

//========================================================================================
// CRectView
//========================================================================================

class CRectView : public FW_CSuperView
{
public:
	FW_DECLARE_CLASS

public:		
	CRectView(Environment *ev, 
				FW_CSuperView* container, 
				const FW_CRect& bounds,
				const FW_CPoint& extent);
	virtual ~ CRectView();

private:
	CRectView(Environment *ev);

//----------------------------------------------------------------------------------------
// Inherited API
public:		
	// ----- Drawing -----
	virtual void		Draw(Environment *ev, ODFacet* facet, ODShape* invalidShape);

	// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment* ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment* ev, FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	New API
protected: 

//----------------------------------------------------------------------------------------
//	Private data
private:
};

#endif
